<template>
  <div>
    <div class="row">
      <div class="col-xs-12 col-md-6">
        <el-input
          v-model="search"
          placeholder="Rechercher"
        />
      </div>
      <div class="col-xs-12 col-md-6">
        <click-button
          @click="clearFilter"
        >
          <template #content>
            Effacer tous les filtres
          </template>
        </click-button>
      </div>
    </div>
    <div class="row">
      <el-table
        ref="managersTable"
        :data="pagedAndFilteredManagers"
        :default-sort="{prop: 'createdAt', order: 'descending'}"
        border
        stripe
        style="width: 100%"
        @selection-change="handleSelectionChange"
      >
        <!--        <el-table-column-->
        <!--          type="selection"-->
        <!--          width="55"-->
        <!--        />-->
        <el-table-column
          prop="createdAt"
          label="Créé le"
          sortable
          width="180"
        >
          <template slot-scope="scope">
            {{ scope.row.createdAt.date | beautifulDate }}
          </template>
        </el-table-column>
        <el-table-column
          prop="email"
          label="Email"
          sortable
          width="180"
        />
        <el-table-column
          prop="id"
          label="Équipe(s)"
        >
          <template slot-scope="scope">
            <p v-if="scope.row.teams.length > 3">
              <el-button
                type="text"
                @click="seeMore(scope.row.teams)"
              >
                Voir les {{ scope.row.teams.length }} éléments
              </el-button>
            </p>
            <p
              v-for="(team, teamIndex) in scope.row.teams"
              v-else
              :key="team.id"
            >
              {{ scope.row.teams[teamIndex].description }}
            </p>
          </template>
        </el-table-column>
        <el-table-column
          prop="connect"
          label="Se connecter en tant que"
        >
          <template slot-scope="scope">
            <click-button
              :disabled="isLoading"
              @click="impersonate(scope.row.email)"
            >
              <template #content>
                <ghost-icon />
              </template>
            </click-button>
          </template>
        </el-table-column>
        <el-table-column
          prop="edit"
          label="Modifier"
        >
          <template slot-scope="scope">
            <click-button
              @click="$router.push({'path':'/admin/gestionnaire/modifier/'+scope.row.id})"
            >
              <template #content>
                <edit-icon />
              </template>
            </click-button>
          </template>
        </el-table-column>
        <el-table-column
          prop="delete"
          label="Supprimer"
        >
          <template slot-scope="scope">
            <click-button
              :disabled="isLoading"
              @click="confirmDeleteManager(scope.row)"
            >
              <template #content>
                <remove-icon />
              </template>
            </click-button>
          </template>
        </el-table-column>
      </el-table>
    </div>
    <div class="row">
      <el-pagination
        :current-page.sync="currentPage"
        :page-size="pageSize"
        layout="total, prev, pager, next"
        :total="filteredManagers.length"
        @current-change="handleCurrentChange"
      />
    </div>
    <confirmation-modal
      id="confirmationModalDelete"
      text="Êtes-vous sûr de vouloir supprimer ce gestionnaire ?"
      @okClicked="performDeleteManager"
    />
  </div>
</template>

<script>
import RemoveIcon from "../../../components/Icon/RemoveIcon";
import {mapActions, mapGetters} from "vuex";
import EditIcon from "../../../components/Icon/EditIcon";
import ConfirmationModal from "../../../components/Modal/ConfirmationModal";
import VanillaToasts from "vanillatoasts";
import GhostIcon from "../../../components/Icon/GhostIcon";
import ClickButton from "../../../components/Button/ClickButton";

export default {
  name: "AdminManagerTable",
  components: {ClickButton, GhostIcon, ConfirmationModal, RemoveIcon, EditIcon},
  data() {
    return {
      search: '',
      multipleSelection: [],
      currentPage: 1,
      pageSize: 10,
      manager: null
    }
  },
  computed: {
    pagedAndFilteredManagers() {
      return !this.search
        ?
        this.managers.slice(this.pageSize * this.currentPage - this.pageSize, this.pageSize * this.currentPage)
        :
        this.managers.filter(manager => manager.email.toLowerCase().includes(this.search.toLowerCase())).slice(this.pageSize * this.currentPage - this.pageSize, this.pageSize * this.currentPage)

    },
    filteredManagers() {
      return this.search ? this.managers.filter(manager => manager.email.toLowerCase().includes(this.search.toLowerCase())) : this.managers
    },
    ...mapGetters([
      'isLoading',
      'managers'
    ])
  },
  methods: {
    ...mapActions([
      'loadingStarts',
      'loadingEnds',
      'deleteManager',
      'impersonate'
    ]),
    confirmDeleteManager(manager) {
      this.manager = manager
      $('#confirmationModalDelete').modal({keyboard: false, backdrop: 'static'})
    },
    performDeleteManager() {
      this.loadingStarts()
      this.deleteManager(this.manager.id)
        .then(() => {
          VanillaToasts.create({
            title: 'Suppression gestionnaire',
            text: 'Opération effectuée avec succès',
            type: 'success',
            timeout: 5000,
          });
          this.loadingEnds()
        })
    },
    handleCurrentChange(val) {
      this.currentPage = val
    },
    toggleSelection(rows) {
      if (rows) {
        rows.forEach(row => {
          this.$refs.managersTable.toggleRowSelection(row);
        });
      } else {
        this.$refs.managersTable.clearSelection();
      }
    },
    handleSelectionChange(val) {
      this.multipleSelection = val;
    },
    filterHandler(value, row, column) {
      const property = column['property'];
      return row[property] === value;
    },
    clearFilter() {
      this.$refs.managersTable.clearFilter();
    },
    seeMore(teams) {
      let text = ''
      teams.forEach(team => {
        text += team.description + ', '
      });
      text = text.substring(0, text.length - 2)
      this.$alert(text, 'Liste des équipes', {
        confirmButtonText: 'Retour'
      });
    }
  }
}
</script>

<style scoped>
.row {
  margin-top: 2vh;
}
</style>